/* Wemos_tapeur
  gepeto@du-libre.org 2018
  objet frappant , commande par Wifi / OSC
  la commande OSC est programmable
  ex /TAP1 ii frequence délai
  ainsi que le SSID/pass
  Pour entrer dans le setup il faut allumer l'ESP en touchant A0
  la led clignote rapidement
  on se connecte sur le SSID SNHACKTAP 192.168.4.1
  apres validation la led clignote doucement

  Matériel: ESP Wemos + driver wemos moteur + platine wemos alimentation

*/
#include <FS.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <DNSServer.h>

// OSC
#include <OSCMessage.h>
#include <OSCBundle.h>
#include <OSCData.h>

#include <WiFiManager.h>         //https://github.com/tzapu/WiFiManager

const char DEVICE_NAME[] = "SNHACKTAP";
const char* ssid     = "SNHACK";
const char* password = "1234567890";
const char* AP_PASS = "1234";
char ssid_base[40] = "";
char pass_base[20] = "";
char osc_server[40] = "192.168.004.98";
char static_ip[16] = "192.168.4.99";
char osc_port[6] = "9005";

//default custom static IP
char static_gw[16] = "192.168.1.1";
char static_sn[16] = "255.255.255.0";
unsigned int osc_port_int = 0 ;          // remote port to receive OSC

unsigned long     frequence[9] = {0};
unsigned long     t_duree[9]   = {0} ;
int          pwm[9]       = {0};
int          sortie[9]    = {16, 5, 4, 0, 2, 14, 12, 13, 15};
// 0,1,2... ok pour 1,2,4,5,6,7 pas 0 3 8
unsigned long     t_debut[9]   = {0} ;
unsigned long     t_encours[9] = {0} ;

WiFiUDP Udp;     // A UDP instance to let us send and receive packets over UDP
const IPAddress outIp(192, 168, 1, 3);     // remote IP to receive OSC
IPAddress _ip;
OSCErrorCode error;
bool shouldSaveConfig = true;
//for LED status
#include <Ticker.h>
Ticker ticker;
//Ticker tap1;
//Ticker tap2;

//converts the pin to an osc address
char * numToOSCAddress(int pin) {
  static char s[10];
  int i = 9;

  s[i--] = '\0';
  do
  {
    s[i] = "0123456789"[pin % 10];
    --i;
    pin /= 10;
  }
  while (pin && i);
  s[i] = '/';
  return &s[i];
}
void tick()
{
  //toggle state
  int state = digitalRead(BUILTIN_LED);  // get the current state of GPIO1 pin
  digitalWrite(BUILTIN_LED, !state);     // set pin to the opposite state
}

void saveConfigCallback () {
  Serial.println("Should save config");
  shouldSaveConfig = true;
}

void arreter(OSCMessage &msg) {
  for (int i = 0; i <= 8; i++) { //  //ok pour 1,2,4,5,6,7
    analogWrite(sortie[i], 0);
    frequence[i] = 0;
    t_duree[i] = 0;
  }
}

void taper(OSCMessage &msg) {
  Serial.println("/tap");
  int pin = (int) msg.getFloat(0);
  if (pin == 1 || pin == 2 || pin == 4  || pin == 5 || pin == 6 || pin == 7 ) { // 1,2,4,5,6,7 ok
    frequence[pin] = (unsigned long)msg.getFloat(1);
    if (frequence[pin] > 0) {
      if (msg.isFloat(2)) {
        t_duree[pin] = (unsigned long)msg.getFloat(2);
      } else t_duree[pin] = 3;

      t_debut[pin] = millis();
      t_encours[pin] = t_debut[pin];

      if (msg.isFloat(3)) pwm[pin] = msg.getFloat(3);
      else pwm[pin] = 1000;
    }
    //if (t_duree[pin] > 0 && 2*frequence[pin] > t_duree[pin]) t_duree[pin] = frequence[pin] + 10;
    //if (t_duree[pin] < 3) t_duree[pin] = 3;
    //t_duree[pin] += millis();
    Serial.println(pin);
    Serial.println(frequence[pin]);
    Serial.println(t_duree[pin]);
    Serial.println(pwm[pin]);
    //Serial.println(t_debut[pin] + t_duree[pin]);
    //Serial.println("=========");

  }
}

void setup(void) {
  Serial.begin(115200);
  //set led pin as output
  pinMode(BUILTIN_LED, OUTPUT);
  //pinMode(Bouton_init, INPUT);
  //BoutonParam = HIGH;
  Serial.println((int32_t)ESP.getChipId());
  delay(1000);
  int BoutonParam = analogRead(A0);
  // start ticker with 0.5 because we start in AP mode and try to connect
  //ticker.attach(0.6, tick);// clignote

  Serial.println(F("sorties :  1, 2, 4, 5, 6, 7 ??")); //ok pour 1,2,4,5,6,7
  Serial.println(F("format: /tap   \(digital\) \(float\) ms \(float\) duree \(int\) pwm-force"));
  Serial.println(F("format: /tap   iffi 6 200 1000 1000"));
  Serial.println(F("/tap 6  vide arrete 6"));
  Serial.println(F("/stop arrete tout"));

  //WiFiManager
  //Local intialization. Once its business is done, there is no need to keep it around
  WiFiManager wifiManager;
  if (BoutonParam >= 15) {
    Serial.println(F("PARAM "));    //reset saved settings
    wifiManager.resetSettings();
    Serial.println(F("WIfi param reset "));
    //ticker.attach(0.2, tick);
    //set custom ip for portal
    //wifiManager.setAPStaticIPConfig(IPAddress(10,0,1,1), IPAddress(10,0,1,1), IPAddress(255,255,255,0));
  }
  //fetches ssid and pass from eeprom and tries to connect
  //if it does not connect it starts an access point with the specified name
  //here  "AutoConnectAP"
  //and goes into a blocking loop awaiting configuration
  wifiManager.autoConnect(DEVICE_NAME);
  //or use this for auto generated name ESP + ChipID
  //wifiManager.autoConnect();

  //_ip.fromString(osc_server);
  osc_port_int = atoi(osc_port);
  Serial.println(F("TOUT OK WiFi connected! IP address: "));
  Serial.println(WiFi.localIP());
  Serial.println(WiFi.hostname());
  Serial.print(F("sur port :"));
  Serial.println(osc_port);
  delay(100);
  Udp.begin(osc_port_int);
  Serial.print(F("Local port: "));
  Serial.println(Udp.localPort());

}
void loop() {
  //////////// OSC ////////////////////////
  //reads and dispatches the incoming message
  OSCMessage msgIN;

  int size;
  //char puce_char[] = "  ";
  if ( (size = Udp.parsePacket()) > 0)
  {
    while (size--)
      msgIN.fill(Udp.read());
    if (!msgIN.hasError()) {
      msgIN.dispatch("/tap", taper);
      msgIN.dispatch("/stop", arreter);
      Serial.println(size);
    } else {
      error = msgIN.getError();
      Serial.print("error: ");
      Serial.println(error);
    }
    Udp.flush();
  }

  //////////////// boucle actions /////////////////
  //delay(300); /////////
  for (int i = 0; i <= 8; i++) { //  //ok pour 1,2,4,5,6,7
    if (i == 0 || i == 3 || i == 8) continue ;  // 1,2,4,5,6,7 ok
    unsigned long t_temps = millis();
    //Serial.println("");
    //Serial.println(t_temps);
    //Serial.println(t_debut[i]);
    //Serial.println(t_duree[i]);
    //Serial.println(t_debut[i] + t_duree[i]);
    //Serial.println("---");
    if (frequence[i] == 0) {
      analogWrite(sortie[i], 0);
      //Serial.println("OF");
      continue;
    }
    if (t_temps <= t_debut[i] + t_duree[i]) { // on est dans l action t_duree
      //Serial.print("o");
      //Serial.println(t_encours[i] + (frequence[i] ));
      if ( t_temps <= t_encours[i] + (frequence[i]) ) {  // debut cycle < prochain cycle
        //Serial.println("n");
        analogWrite(sortie[i], pwm[i]);
      } else if ( t_temps <= t_encours[i] + ( frequence[i] * 2) ) {
        //Serial.println("f");
        analogWrite(sortie[i], 0);                            // entre 2 cycle
      }
      else {
        t_encours[i] = millis();                   // recommence nouveau cycle
      }
    } else { // en dehors de l action
      analogWrite(sortie[i], 0);
    }
  }
}
